 %%      

disp('rank correlations: monotone')
disp('coll and comp: full, satisfying monotonicity, not satisfying monotonicity')
disp('line below is stat sigin')

[temp_c1,temp_p1]=corr(comp_deduc,coll_deduc,'type','Spearman');
[temp_c2,temp_p2]=corr(comp_deduc(monotone==1),coll_deduc(monotone==1),'type','Spearman');
[temp_c3,temp_p3]=corr(comp_deduc(monotone~=1),coll_deduc(monotone~=1),'type','Spearman');

disp([temp_c1 temp_c2 temp_c3])
disp([temp_p1 temp_p2 temp_p3])

disp('rank correlations')
disp('coll and home: full, satisfying monotonicity, not satisfying monotonicity')

[temp_c1,temp_p1]=corr(home_deduc,coll_deduc,'type','Spearman');
[temp_c2,temp_p2]=corr(home_deduc(monotone==1),coll_deduc(monotone==1),'type','Spearman');
[temp_c3,temp_p3]=corr(home_deduc(monotone~=1),coll_deduc(monotone~=1),'type','Spearman');

disp([temp_c1 temp_c2 temp_c3])
disp([temp_p1 temp_p2 temp_p3])


disp('rank correlations')
disp('comp and home: full, satisfying monotonicity, not satisfying monotonicity')

[temp_c1,temp_p1]=corr(home_deduc,comp_deduc,'type','Spearman');
[temp_c2,temp_p2]=corr(home_deduc(monotone==1),comp_deduc(monotone==1),'type','Spearman');
[temp_c3,temp_p3]=corr(home_deduc(monotone~=1),comp_deduc(monotone~=1),'type','Spearman');

disp([temp_c1 temp_c2 temp_c3])
disp([temp_p1 temp_p2 temp_p3])

%%
disp('rank correlations')
disp('coll and comp: satisfying linearity, not satisfying linearity')
[temp_c2,temp_p2]=corr(comp_deduc(linear==1),coll_deduc(linear==1),'type','Spearman');
[temp_c3,temp_p3]=corr(comp_deduc(linear~=1),coll_deduc(linear~=1),'type','Spearman');

disp([temp_c2 temp_c3])
disp([temp_p2 temp_p3])


disp('rank correlations')
disp('coll and home: full, satisfying linearity, not satisfying linearity')
[temp_c2,temp_p2]=corr(home_deduc(linear==1),coll_deduc(linear==1),'type','Spearman');
[temp_c3,temp_p3]=corr(home_deduc(linear~=1),coll_deduc(linear~=1),'type','Spearman');

disp([temp_c2 temp_c3])
disp([temp_p2 temp_p3])


disp('rank correlations')
disp('comp and home:full, satisfying linearity, not satisfying linearity')

[temp_c2,temp_p2]=corr(home_deduc(linear==1),comp_deduc(linear==1),'type','Spearman');
[temp_c3,temp_p3]=corr(home_deduc(linear~=1),comp_deduc(linear~=1),'type','Spearman');

disp([temp_c2 temp_c3])
disp([temp_p2 temp_p3])

%%
disp('rank correlations')
disp('coll and comp:  full, satisfying quadraticity, not satisfying quadraticity')
[temp_c2,temp_p2]=corr(comp_deduc(quadratic==1),coll_deduc(quadratic==1),'type','Spearman');
[temp_c3,temp_p3]=corr(comp_deduc(quadratic~=1),coll_deduc(quadratic~=1),'type','Spearman');

disp([temp_c2 temp_c3])
disp([temp_p2 temp_p3])


disp('rank correlations')
disp('coll and home:  full, satisfying quadraticity, not satisfying quadraticity')
[temp_c2,temp_p2]=corr(home_deduc(quadratic==1),coll_deduc(quadratic==1),'type','Spearman');
[temp_c3,temp_p3]=corr(home_deduc(quadratic~=1),coll_deduc(quadratic~=1),'type','Spearman');

disp([temp_c2 temp_c3])
disp([temp_p2 temp_p3])


disp('rank correlations')
disp('comp and home: full, satisfying quadraticity, not satisfying quadraticity')
[temp_c2,temp_p2]=corr(home_deduc(quadratic==1),comp_deduc(quadratic==1),'type','Spearman');
[temp_c3,temp_p3]=corr(home_deduc(quadratic~=1),comp_deduc(quadratic~=1),'type','Spearman');

disp([temp_c2 temp_c3])
disp([temp_p2 temp_p3])



%%

% b_LBS    =  Omega_min_out;
% b_UBS    =  Omega_max_out;
% b_lambdas= lambdas(linear==1,:);
% 
% bandwidth   = .001:.001:0.02;
% N_bandwidth = length(bandwidth);

% [~,AIC_u] = kernel_regression(reshape(b_lambdas,[],1),reshape(b_UBS,[],1),length(b_lambdas)*3,bandwidth,N_bandwidth);
% [~,AIC_l] = kernel_regression(reshape(b_lambdas,[],1),reshape(b_LBS,[],1),length(b_lambdas)*3,bandwidth,N_bandwidth);
% 
% [~,temp_u]= min(AIC_u);
% [~,temp_l]= min(AIC_l);
% 
% 
% b_optimal_u =bandwidth(temp_u);
% b_optimal_l =bandwidth(temp_l);
% 
% b_optimal = mean(b_optimal_u,b_optimal_l);
% 
b_optimal = .0095;


lambdas_grid = linspace(.001,.16,50);
%%
figure


[LBS,UBS]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Monotone,LOWER_BAR,UPPER_BAR,Num_Obs);

subplot 221
r_u=ksr(reshape(lambdas(monotone==1,:),[],1),reshape(UBS(monotone==1,:),[],1),b_optimal,length(lambdas_grid),lambdas_grid);
r_l=ksr(reshape(lambdas(monotone==1,:),[],1),reshape(LBS(monotone==1,:),[],1),b_optimal,length(lambdas_grid),lambdas_grid);
[b_l,b_u]= bootstrap_intervals(reshape(LBS(monotone==1,:),[],1),reshape(UBS(monotone==1,:),[],1),reshape(lambdas(monotone==1,:),[],1),b_optimal,lambdas_grid,r_u.f,r_l.f);
plot(lambdas_grid,.5*(r_u.f+r_l.f),'b--','linewidth',3)
hold on
plot(r_l.x,r_l.f,'b','linewidth',2)
plot(r_u.x,r_u.f,'b','linewidth',2)
plot(lambdas_grid,b_l,'r-.','linewidth',2,'markersize',1)
plot(lambdas_grid,b_u,'r-.','linewidth',2,'markersize',1)
xlim([0 .16])
ylim([0 .46])
title('Monotonicity' )


r_u_monotone = r_u.f;
r_l_monotone = r_l.f;

b_u_monotone = b_u;
b_l_monotone = b_l;


subplot 222
r_u=ksr(reshape(lambdas(quadratic==1,:),[],1),reshape(QQ_Omega_max_out(quadratic==1,:),[],1),b_optimal,length(lambdas_grid),lambdas_grid);
r_l=ksr(reshape(lambdas(quadratic==1,:),[],1),reshape(QQ_Omega_min_out(quadratic==1,:),[],1),b_optimal,length(lambdas_grid),lambdas_grid);
[b_l,b_u]= bootstrap_intervals(reshape(QQ_Omega_min_out(quadratic==1,:),[],1),reshape(QQ_Omega_max_out(quadratic==1,:),[],1),reshape(lambdas(quadratic==1,:),[],1),b_optimal,lambdas_grid,r_u.f,r_l.f);
plot(lambdas_grid,.5*(r_u.f+r_l.f),'b--','linewidth',3)
hold on
plot(r_l.x,r_l.f,'b','linewidth',2)
plot(r_u.x,r_u.f,'b','linewidth',2)
plot(lambdas_grid,b_l,'r-.','linewidth',2,'markersize',1)
plot(lambdas_grid,b_u,'r-.','linewidth',2,'markersize',1)
xlim([0 .16])
ylim([0 .46])
title('Quadtraticity' )

r_u_quadratic = r_u.f;
r_l_quadratic = r_l.f;

b_u_quadratic = b_u;
b_l_quadratic = b_l;



subplot 223
b_LBS    =  Omega_min_out;
b_UBS    =  Omega_max_out;
b_lambdas= lambdas(linear==1,:);
 
r_u=ksr(reshape(b_lambdas,[],1),reshape(b_UBS,[],1),b_optimal,length(lambdas_grid),lambdas_grid);
r_l=ksr(reshape(b_lambdas,[],1),reshape(b_LBS,[],1),b_optimal,length(lambdas_grid),lambdas_grid);
[b_l,b_u]= bootstrap_intervals(b_LBS,b_UBS,b_lambdas,b_optimal,lambdas_grid,r_u.f,r_l.f);
plot(lambdas_grid,.5*(r_u.f+r_l.f),'b--','linewidth',3)
hold on
plot(r_l.x,r_l.f,'b','linewidth',2)
plot(r_u.x,r_u.f,'b','linewidth',2)

plot(lambdas_grid,b_l,'r-.','linewidth',2,'markersize',1)
plot(lambdas_grid,b_u,'r-.','linewidth',2,'markersize',1)
xlim([0 .16])
ylim([0 .46])
hold off
title('Linearity' )
xlabel('\mu')


r_u_linear = r_u.f;
r_l_linear = r_l.f;

b_u_linear = b_u;
b_l_linear = b_l;



subplot 224
r_u=ksr(reshape(lambdas(unit_slope,:),[],1),reshape(UBS_unit_slope(unit_slope,:),[],1),b_optimal,length(lambdas_grid),lambdas_grid);
r_l=ksr(reshape(lambdas(unit_slope,:),[],1),reshape(LBS_unit_slope(unit_slope,:),[],1),b_optimal,length(lambdas_grid),lambdas_grid);
[b_l,b_u]= bootstrap_intervals(reshape(LBS_unit_slope(unit_slope,:),[],1),reshape(UBS_unit_slope(unit_slope,:),[],1),reshape(lambdas(unit_slope,:),[],1),b_optimal,lambdas_grid,r_u.f,r_l.f);
plot(lambdas_grid,.5*(r_u.f+r_l.f),'b--','linewidth',3)
hold on
plot(r_l.x,r_l.f,'b','linewidth',2)
plot(lambdas_grid,b_l,'r-.','linewidth',2,'markersize',1)

legend('Midpoints','Lower and upper bounds','Confidence bands','Location','Northwest')
legend boxoff
plot(r_u.x,r_u.f,'b','linewidth',2)
plot(lambdas_grid,b_u,'r-.','linewidth',2,'markersize',1)
xlim([0 .16])
ylim([0 .46])
hold off
title('Unit slope' )
xlabel('\mu')
legend

r_u_unit_slope = r_u.f;
r_l_unit_slope = r_l.f;

b_u_unit_slope = b_u;
b_l_unit_slope = b_l;



r_lambda_grid = r_u.x;
b_lambda_grid = lambdas_grid;
             
print -depsc2 Figure_3

%%
figure

%%

load pwl_outcome

omega_size_monotone   = r_u_monotone  -r_l_monotone;
omega_size_quadratic  = r_u_quadratic -r_l_quadratic;
omega_size_linear     = r_u_linear    -r_l_linear;
omega_size_unit_slope = r_u_unit_slope-r_l_unit_slope;



subplot 211
plot(r_lambda_grid,omega_size_monotone, 'r','linewidth',2)
hold on
plot(r_lambda_grid,omega_size_quadratic, 'k-.','linewidth',2)
plot(r_lambda_grid,omega_size_linear   , 'b--','linewidth',3)
plot(r_lambda_grid,omega_size_unit_slope, 'm-o','linewidth',2,'markersize',2)
plot(PWL_Points,PWL_Conf_Band_Low-PWL_Conf_Band_High, 'g--','linewidth',1)
xlim([0 .16])
legend('Monotone','Quadratic','Linear','Unit Slope','BMOT 95% CB','location','northwest')
legend boxoff
title('Interval Width')

compare_bench = interp1(PWL_Points,PWL_Conf_Band_Low-PWL_Conf_Band_High,r_lambda_grid,'pchip');

omega_size_monotone   = (r_u_monotone  -r_l_monotone)./compare_bench;
omega_size_quadratic  = (r_u_quadratic -r_l_quadratic)./compare_bench;
omega_size_linear     = (r_u_linear    -r_l_linear)./compare_bench;
omega_size_unit_slope = (r_u_unit_slope-r_l_unit_slope)./compare_bench ;


subplot 212

plot(r_lambda_grid,omega_size_monotone, 'r','linewidth',2)
hold on
plot(r_lambda_grid,omega_size_quadratic, 'k-.','linewidth',2)
plot(r_lambda_grid,omega_size_linear   , 'b--','linewidth',3)
plot(r_lambda_grid,omega_size_unit_slope, 'm-o','linewidth',2,'markersize',2)

legend('Monotone','Quadratic','Linear','Unit Slope','location','northwest')
legend boxoff
title('Interval Width relative to BMOT 95% CB')
xlim([0 .16])

xlabel('\mu')

disp([mean(omega_size_monotone) 
mean(omega_size_quadratic)
mean(omega_size_linear) 
mean(omega_size_unit_slope)])



