function [b_l,b_u,c_alpha]= bootstrap_intervals(LBS,UBS,lambdas,b_optimal,lambdas_grid,r_u_hat,r_l_hat)

rng(1234)
BtS = 200;
Num_Obs= length(LBS);
parfor bts = 1:BtS
    R = randi(Num_Obs,1,Num_Obs);
    lambdasx = lambdas(R,:); %#ok<*PFBNS>
    UBSx     = UBS(R,:);
    LBSx     = LBS(R,:);
    r_u(bts)=ksr(reshape(lambdasx,[],1),reshape(UBSx,[],1),b_optimal,length(lambdas_grid),lambdas_grid);
    r_l(bts)=ksr(reshape(lambdasx,[],1),reshape(LBSx,[],1),b_optimal,length(lambdas_grid),lambdas_grid);
end
  
parfor bts = 1:BtS
diff_1(bts,:)= r_u(bts).f-r_u_hat;
diff_2(bts,:)= r_l(bts).f-r_l_hat;

end    
t = max(max(0,-diff_1),max(0,diff_2));

c_alpha = quantile(t,.95);

b_u     = r_u_hat+c_alpha;
b_l     = r_l_hat-c_alpha;
