function [ distance_out,distance,AA,BB] = omega_distance(candidate,mu_out,Omega_max_out,Omega_min_out,square_or_not,XX,pol_length,mu_length)

% pol_length=2: linear, pol_length =3: quadratic etc...
% mu_length : number of mus per household
AA  =  repmat(exp(XX*candidate(1               :  end/pol_length)'),1,mu_length);
BB  =  repmat(exp(XX*candidate(1+end/pol_length:2*end/pol_length)'),1,mu_length);
tt            = AA+BB.*mu_out;
for ii=2:pol_length-1
    CC            = repmat(exp(XX*candidate(1+ii*end/pol_length:  (ii+1)*end/pol_length)'),1,mu_length);
    tt            = tt+CC*mu_out.^ii;
end
Ind_Max=(tt-Omega_max_out>0);
Ind_Min=(tt-Omega_min_out<0);
distance=(tt-Omega_max_out).*Ind_Max+(-tt+Omega_min_out).*Ind_Min;
if square_or_not==1
    distance_out = sum(sum(distance.^2));
else
    distance_out = sum(sum(distance));
end

