function [ distance_out,distance] = omega_distance_fast(candidate,mu_out,Omega_max,Omega_min,square_or_not,pol_length,mu_number,Num_obs)

% pol_length=2: linear, pol_length =3: quadratic etc...
% mu_number : number of mus per household

if pol_length>0
    
    AA  =  repmat((candidate(1)),Num_obs,mu_number);
else
    AA=0;
end
if pol_length>1
    BB  =  repmat((candidate(2)),Num_obs,mu_number);
else
    BB=1;
end
if pol_length>2
    CC =  repmat((candidate(3)),Num_obs,mu_number);
else
    CC=0;
end
tt            = AA+BB.*mu_out+CC.*(mu_out.*mu_out);
for ii=3:pol_length-1
    CC            = repmat((candidate(ii+1)),Num_obs,mu_number);
    tt            = tt+CC.*mu_out.^ii;
end
Ind_Max=(tt-Omega_max>0);
Ind_Min=(tt-Omega_min<0);
distance=(tt-Omega_max).*Ind_Max+(-tt+Omega_min).*Ind_Min;
if square_or_not==1
    distance_out = sum(sum(distance.^2));
else
    distance_out = sum(sum(distance));
end

