
temp_0= zeros(1,length(RR_vec));
temp_1= zeros(1,length(RR_vec));
temp_2= zeros(1,length(RR_vec));
temp_3= zeros(1,length(RR_vec));
temp_4= zeros(1,length(RR_vec));
temp_5= zeros(1,length(RR_vec));

for jj=1:length(RR_vec);
    temp_0(jj)= sum((sum(PLAUSIBILITY(:,1:jj),2)>0));
    temp_1(jj)= sum((sum(MONOTONICITY(:,1:jj),2)>0));
    temp_2(jj)= sum((sum(QUADRATIC(:,1:jj),2)>0));
    temp_3(jj)= sum((sum(LINEAR(:,1:jj),2)>0));
    temp_4(jj)= sum((sum(UNIT_SLOPE(:,1:jj),2)>0));
    temp_5(jj)= sum((sum(CARA(:,1:jj),2)>0));
end


figure
if r_max==10.8
    
    
    plot(RR_vec,temp_1/Num_Obs*100,'b--','linewidth',2,'markersize',7)
    hold on
    plot(RR_vec,temp_2/Num_Obs*100,'k-+','linewidth',2,'markersize',4)
    plot(RR_vec,temp_3/Num_Obs*100,'m-.','linewidth',2,'markersize',7)
    plot(RR_vec,temp_4/Num_Obs*100,'g','linewidth',2,'markersize',7)
    plot(RR_vec,temp_5/Num_Obs*100,'ro','linewidth',2,'markersize',2)
    
    
    xlabel('Upper bound on r_i')
    ylabel('Percent of rationalizable households')
    ylim([0 100])
    xlim([0 r_max*1e-3])
    legend('Monotonicity','Quadraticity','Linearity','Unit slope','Zero intercept','location','southeast')
    legend boxoff
    
    print -depsc2 Figure_2
    
else
    figure
    
    plot(RR_vec,temp_0./Total_Num_Obs*100,'r-+','linewidth',2,'markersize',4)
    hold on
    
    plot(RR_vec,temp_1./Total_Num_Obs*100,'b--','linewidth',2,'markersize',7)
    plot(RR_vec,temp_2./Total_Num_Obs*100,'k-+','linewidth',2,'markersize',4)
    plot(RR_vec,temp_3./Total_Num_Obs*100,'m-.','linewidth',2,'markersize',7)
    plot(RR_vec,temp_4./Total_Num_Obs*100,'g','linewidth',2,'markersize',7)
    plot(RR_vec,temp_5./Total_Num_Obs*100,'ro','linewidth',2,'markersize',2)
    
    
    xlabel('Upper bound on r_i')
    ylabel('Percent of all households')
    ylim([0 100])
    legend('Plausibility','Monotonicity','Quadraticity','Linearity','Unit slope','Zero intercept','location','southeast')
    legend boxoff
    
    
    
    print -depsc2 Figure_A3_v1
    figure
    
    plot(RR_vec,temp_1./temp_0*100,'b--','linewidth',2,'markersize',7)
    hold on
    
    plot(RR_vec,temp_2./temp_0*100,'k-+','linewidth',2,'markersize',4)
    plot(RR_vec,temp_3./temp_0*100,'m-.','linewidth',2,'markersize',7)
    plot(RR_vec,temp_4./temp_0*100,'g','linewidth',2,'markersize',7)
    plot(RR_vec,temp_5./temp_0*100,'ro','linewidth',2,'markersize',2)
    
    
    xlabel('Upper bound on r_i')
    ylabel('Percent of rationalizable households')
    ylim([0 100])
    legend('Monotonicity','Quadraticity','Linearity','Unit slope','Zero intercept','location','southeast')
    legend boxoff
    
    print -depsc2 Figure_A3_v2
    
    
    figure
    subplot 211
    
    plot(RR_vec,temp_0./Total_Num_Obs*100,'r-+','linewidth',2,'markersize',4)
    hold on
    
    plot(RR_vec,temp_1./Total_Num_Obs*100,'b--','linewidth',2,'markersize',7)
    plot(RR_vec,temp_2./Total_Num_Obs*100,'k-+','linewidth',2,'markersize',4)
    plot(RR_vec,temp_3./Total_Num_Obs*100,'m-.','linewidth',2,'markersize',7)
    plot(RR_vec,temp_4./Total_Num_Obs*100,'g','linewidth',2,'markersize',7)
    plot(RR_vec,temp_5./Total_Num_Obs*100,'ro','linewidth',2,'markersize',2)
    
    
    xlabel('Upper bound on r_i')
    ylabel('Percent of all households')
    ylim([0 100])
    legend('Plausibility','Monotonicity','Quadraticity','Linearity','Unit slope','Zero intercept','location','southeast')
    legend boxoff
    
    
    
    subplot 212
    
    plot(RR_vec,temp_1./temp_0*100,'b--','linewidth',2,'markersize',7)
    hold on
    
    plot(RR_vec,temp_2./temp_0*100,'k-+','linewidth',2,'markersize',4)
    plot(RR_vec,temp_3./temp_0*100,'m-.','linewidth',2,'markersize',7)
    plot(RR_vec,temp_4./temp_0*100,'g','linewidth',2,'markersize',7)
    plot(RR_vec,temp_5./temp_0*100,'ro','linewidth',2,'markersize',2)
    
    
    xlabel('Upper bound on r_i')
    ylabel('Percent of rationalizable households')
    ylim([0 100])
    legend('Monotonicity','Quadraticity','Linearity','Unit slope','Zero intercept','location','southeast')
    legend boxoff
    
    print -depsc2 Figure_A3
    
end