
RR_plotter      = 0:1e-3:1.1e-2;

hist_Monotone   = hist(RR_Mins_Monotone(monotone==1)  ,RR_plotter);
hist_Quad       = hist(RR_Mins_Quadratic(quadratic==1),RR_plotter);
hist_Linear     = hist(RR_Mins_Linear(linear==1),RR_plotter);
hist_Unit_Slope = hist(RR_Mins_Unit_Slope(unit_slope==1),RR_plotter);
hist_CARA       = hist(RR_Mins_CARA(cara==1),RR_plotter);




mean_Monotone   = mean(RR_Mins_Monotone(monotone==1)  )*1000;
mean_Quad       = mean(RR_Mins_Quadratic(quadratic==1))*1000;
mean_Linear     = mean(RR_Mins_Linear(linear==1))*1000;
mean_Unit_Slope = mean(RR_Mins_Unit_Slope(unit_slope==1))*1000;
mean_CARA       = mean(RR_Mins_CARA(cara==1))*1000;


std_Monotone   = std(RR_Mins_Monotone(monotone==1)  )*1000;
std_Quad       = std(RR_Mins_Quadratic(quadratic==1))*1000;
std_Linear     = std(RR_Mins_Linear(linear==1))*1000;
std_Unit_Slope = std(RR_Mins_Unit_Slope(unit_slope==1))*1000;
std_CARA       = std(RR_Mins_CARA(cara==1))*1000;


median_Monotone   = quantile(RR_Mins_Monotone(monotone==1),.5)*1000;
median_Quad       = quantile(RR_Mins_Quadratic(quadratic==1),.5)*1000;
median_Linear     = quantile(RR_Mins_Linear(linear==1),.5)*1000;
median_Unit_Slope = quantile(RR_Mins_Unit_Slope(unit_slope==1),.5)*1000;
median_CARA       = quantile(RR_Mins_CARA(cara==1),.5)*1000;

subplot 321
bar(RR_plotter*1000,hist_Monotone/sum(hist_Monotone),'b','linewidth',1,'edgecolor','b')
title('Monotonicity')
axis('tight')
ylim([0 1])
subplot 322
bar(RR_plotter*1000,hist_Quad/sum(hist_Quad),'b','linewidth',1,'edgecolor','b')
title('Quadraticity')
axis('tight')
ylim([0 1])

subplot 323
bar(RR_plotter*1000,hist_Linear/sum(hist_Linear),'b','linewidth',1,'edgecolor','b')
title('Linearity')
axis('tight')
ylim([0 1])

subplot 324
bar(RR_plotter*1000,hist_Unit_Slope/sum(hist_Unit_Slope),'b','linewidth',1,'edgecolor','b')
title('Unit slope')
axis('tight')
ylim([0 1])

xlabel('r_i x 10^-^3')

subplot 325
bar(RR_plotter*1000,hist_CARA/sum(hist_CARA),'b','linewidth',1,'edgecolor','b')
title('Zero intercept')
axis('tight')
ylim([0 1])

xlabel('r_i x 10^-^3')


                                                                    text(1.6*max(RR_plotter*1000),.90,'Median  ','fontsize',8); text(1.75*max(RR_plotter*1000),.90,'   Mean','fontsize',8); text(1.9*max(RR_plotter*1000),.90,'   Std. dev.     x 10 ^-^3','fontsize',8)
text(1.25*max(RR_plotter*1000),.75, 'Monotonicity','fontsize',8) ;  text(1.6*max(RR_plotter*1000),.75,['  0.00       ' num2str(mean_Monotone,1)   '       ' num2str(std_Monotone,2)],'fontsize',8)
text(1.25*max(RR_plotter*1000),.60, 'Quadraticity','fontsize',8)  ; text(1.6*max(RR_plotter*1000),.60,['  0.00       ' num2str(mean_Quad,1)    '0       '  num2str(std_Quad,2)],'fontsize',8)
text(1.25*max(RR_plotter*1000),.45, 'Linearity','fontsize',8)     ; text(1.6*max(RR_plotter*1000),.45,['  0.00       ' num2str(mean_Linear,2)   '       '  num2str(std_Linear,2) '0'],'fontsize',8)
text(1.25*max(RR_plotter*1000),.30, 'Unit slope','fontsize',8)    ; text(1.6*max(RR_plotter*1000),.30,['  0.00       ' num2str(mean_Unit_Slope,2)  '       '  num2str(std_Unit_Slope,2)  ] ,'fontsize',8)
text(1.25*max(RR_plotter*1000),.15, 'Zero intercept','fontsize',8); text(1.6*max(RR_plotter*1000),.15,['  ' num2str(median_CARA,2) '0       ' num2str(mean_CARA,3)   '       ' num2str(std_CARA,3)],'fontsize',8)



print -depsc2 Figure_1

