[nLBS,nUBS,nlambdas,nPlausibility,nMonotonicity,nLBSraw,nUBSraw]  = test_04_06_15_for_epsilon_m(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Monotone,LOWER_BAR,UPPER_BAR,Num_Obs);

nEpsilon_L                =      -(nLBS-nLBSraw);
nEpsilon_U                =       (nUBS-nUBSraw);

L_EV     = zeros(Num_Obs,1);
L_EV_opt = zeros(Num_Obs,1);

U_EV     = zeros(Num_Obs,1);
U_EV_opt = zeros(Num_Obs,1);

for jj=1:length(nlambdas)
    if nEpsilon_L(jj,1)>0
        lambda_temp=[lambda_comp(jj) lambda_coll(jj) lambda_home(jj)];
        zz = find(lambda_temp==nlambdas(jj,1));
        if zz==3
            L_EV(jj)      =     -home_prem(jj)  - home_deduc(jj)*nLBS(jj,1);
            L_EV_opt(jj)  = max(  -pp_home(jj,:)- deduc_list_home*nLBSraw(jj,1));
            
        elseif zz==2
            
            L_EV(jj)      =     -coll_prem(jj)  - coll_deduc(jj)*nLBS(jj,1);
            L_EV_opt(jj)  = max(  -pp_coll(jj,:)- deduc_list_coll*nLBSraw(jj,1));
        else
            
            L_EV(jj)      =     -comp_prem(jj)  - comp_deduc(jj)*nLBS(jj,1);
            L_EV_opt(jj)  = max(  -pp_comp(jj,:)- deduc_list_comp*nLBSraw(jj,1));
        end
    end
    if nEpsilon_U(jj,3)>0
        lambda_temp=[lambda_comp(jj) lambda_coll(jj) lambda_home(jj)];
        zz = find(lambda_temp==nlambdas(jj,1));
        if zz==3
            U_EV(jj)      =     -home_prem(jj)  - home_deduc(jj)*nUBS(jj,3);
            U_EV_opt(jj)  = max(  -pp_home(jj,:)- deduc_list_home*nUBSraw(jj,3));
            
        elseif zz==2
            
            U_EV(jj)      =     -coll_prem(jj)  - coll_deduc(jj)*nUBS(jj,3);
            U_EV_opt(jj)  = max(  -pp_coll(jj,:)- deduc_list_coll*nUBSraw(jj,3));
        else
            
            U_EV(jj)      =     -comp_prem(jj)  - comp_deduc(jj)*nUBS(jj,3);
            U_EV_opt(jj)  = max(  -pp_comp(jj,:)- deduc_list_comp*nUBSraw(jj,3));
        end
    end
end

diff_L =L_EV( nEpsilon_L(:,1)>0) - L_EV_opt( nEpsilon_L(:,1)>0);
diff_U =U_EV( nEpsilon_U(:,3)>0) - U_EV_opt( nEpsilon_U(:,3)>0);


diff_L_percent =(L_EV( nEpsilon_L(:,1)>0) - L_EV_opt( nEpsilon_L(:,1)>0))./L_EV_opt( nEpsilon_L(:,1)>0);
diff_U_percent =(U_EV( nEpsilon_U(:,3)>0) - U_EV_opt( nEpsilon_U(:,3)>0))./U_EV_opt( nEpsilon_U(:,3)>0);


disp([mean(abs(diff_L)) mean(abs(diff_U))])
disp([mean(abs(diff_L_percent)) mean(abs(diff_U_percent))])

% disp([mean(abs(diff_L)) mean(abs(diff_U)) mean(abs(diff_L)+abs(diff_U))]/Num_obs*(1-mean(nMonotonicity)))
% disp([mean(abs(diff_L_percent)) mean(abs(diff_U_percent)) mean(abs(diff_L_percent)+abs(diff_U_percent))]/Num_obs*(1-mean(nMonotonicity)))
disp('average dollar cost of deviation and EV percent deviation')
disp((mean(abs(diff_L))*length(diff_L)+mean(abs(diff_U))*length(diff_U))/(length(diff_U)+length(diff_L)))
disp((mean(abs(diff_L_percent))*length(diff_L)+mean(abs(diff_U_percent))*length(diff_U))/(length(diff_U)+length(diff_L)))

disp('Q stat for mononotonicity')
disp(mean(mean(nEpsilon_L+nEpsilon_U)))


[~,~,lambdas,~,~,LBSraw,UBSraw]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Quadratic,LOWER_BAR,UPPER_BAR,Num_Obs);

parfor ii=1:Num_Obs
    if quadratic(ii) ==1
        quad_distance(ii)                         =   0;
        qflag(ii) = 0;
    else
        [temp,quad_distance(ii),qflag(ii)]= fmincon(@omega_distance_fast,[0 1 0],[0 -1 -2*max(lambdas(ii,:));1  max(lambdas(ii,:)) max(lambdas(ii,:)).^2],[ 0 1],[],[],[0 0 0], [1 25 25 ],[],optimset('display','off'),lambdas(ii,:),UBSraw(ii,:),LBSraw(ii,:),0,3,3,1);

    end
end

disp((mean(quad_distance))*100)

% [~,~,lambdas,~,~,LBSraw,UBSraw]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
%         comp_deduc,coll_deduc,home_deduc,RR_Mins_Linear,LOWER_BAR,UPPER_BAR,Num_Obs);

parfor ii=1:Num_Obs
    if linear(ii) ==1
        linear_distance(ii)                         =   0;
        lflag(ii) = 0;
    else
        [temp,linear_distance(ii),lflag(ii)]= fmincon(@omega_distance_fast,[0 1 ],[],[],[],[],[0 0],[1 1/max(lambdas(ii,:))],[],optimset('display','off'),lambdas(ii,:),UBSraw(ii,:),LBSraw(ii,:),0,2,3,1);

    end
end
disp('linear')

disp((mean(linear_distance))*100)

[~,~,lambdas,~,~,LBSraw,UBSraw]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_Unit_Slope,LOWER_BAR,UPPER_BAR,Num_Obs);

    
parfor ii=1:Num_Obs
    if unit_slope(ii) ==1
        unit_slope_distance(ii)                         =   0;
    else
     [temp,unit_slope_distance(ii)]= fmincon(@omega_distance_fast,0.1,[],[],[],[],0,1,[],optimset('display','off'),lambdas(ii,:),UBSraw(ii,:),LBSraw(ii,:),0,1,3,1);

    end
end
disp('unit slope')

disp((mean(unit_slope_distance))*100)

disp('CARA')
[~,~,lambdas,~,~,LBSraw,UBSraw]  = test_04_06_15(lambda_comp,lambda_coll,lambda_home,pp_comp,pp_coll,pp_home,comp_prem,coll_prem,home_prem,deduc_list_comp,deduc_list_coll,deduc_list_home,...
        comp_deduc,coll_deduc,home_deduc,RR_Mins_CARA,LOWER_BAR,UPPER_BAR,Num_Obs);

parfor ii=1:Num_Obs
    if cara(ii) ==1
        cara_distance(ii)                         =   0;
    else
        cara_distance(ii)= omega_distance_fast([0 1],lambdas(ii,:),UBSraw(ii,:),LBSraw(ii,:),0,0,3,1);

    end
end
disp((mean(cara_distance))*100)



