function r=kernel_regression_aux_1(x,y,b,N)

r.n=length(x);
r.b=b;

% Gaussian kernel function - higher order
kerf=@(z).5*(3-z.*z).*exp(-z.*z/2)/sqrt(2*pi);

r.x      = x;
r.f      =zeros(1,N);
r.weights=zeros(N,N);

for k=1:N
    z=kerf((r.x(k)-x)/b);
    r.f(k)=sum(z.*y)/sum(z);
end

temp_1 = repmat(r.x',N,1);
temp_2 = repmat(r.x,1,N);
r.weights  = kerf((temp_1-temp_2)/b);
