function [ distance_out,W] = omega_distance_auxiliary(candidate,mu_out,Omega_max_out,Omega_min_out)
candidate_a   = candidate(1);
candidate_b   = candidate(2);

tt            = repmat(candidate_a+candidate_b*mu_out,length(Omega_max_out),1);
Ind_Max=(tt-Omega_max_out>0);
Ind_Min=(tt-Omega_min_out<0);
distance=(tt-Omega_max_out).*Ind_Max+(-tt+Omega_min_out).*Ind_Min;
distance_out = sum(sum(distance));

temp_0        = repmat(mu_out,length(Omega_max_out),1);
temp_11       = mean(        (Ind_Max-Ind_Min),2);
temp_22       = mean(temp_0.*(Ind_Max-Ind_Min),2);

W             = zeros(2,2);
W(1,1)        = temp_11'*temp_11;
W(1,2)        = temp_11'*temp_22;
W(2,1)        = W(1,2);
W(2,2)        = temp_22'*temp_22;
W             = W/length(Omega_max_out);
end

