function [ distance_out,distance_all] = omega_distance_multiple(candidate,mu_out,Omega_max,Omega_min,square_or_not,pol_length,mu_length,Num_obs,Num_omegas)

% pol_length=2: linear, pol_length =3: quadratic etc...
% mu_length : number of mus per household

for ii=1:Num_omegas
    AA(ii)=  candidate((ii-1)*pol_length+1); %#ok<*AGROW>
    BB(ii)=  candidate((ii-1)*pol_length+2);%repmat(candidate((ii-1)*pol_length+2),Num_obs,mu_length);
    %CC(ii)=  candidate((ii-1)*pol_length+3);%repmat(candidate((ii-1)*pol_length+3),Num_obs,mu_length);
end
AA= repmat(reshape(AA,1,1,Num_omegas),[ Num_obs mu_length  1]);
BB= repmat(reshape(BB,1,1,Num_omegas),[ Num_obs mu_length  1]);
%CC= repmat(CC,[ Num_obs mu_length  1]);

tt            = AA+BB.*repmat(mu_out,[ 1 1 Num_omegas]);%+CC.*repmat(mu_out,[ 1 1 Num_omegas]);


Ind_Max=(tt-repmat(Omega_max,[ 1 1 Num_omegas])>0);
Ind_Min=(tt-repmat(Omega_min,[ 1 1 Num_omegas])<0);

distance=(tt-repmat(Omega_max,[ 1 1 Num_omegas])).*Ind_Max+(-tt+repmat(Omega_min,[ 1 1 Num_omegas])).*Ind_Min;
if square_or_not==1
    distance= distance.^2;
end
distance     = squeeze(sum(distance,2));
distance_all = distance;

distance     = min(distance,[],2);

distance_out = sum(distance);

